//+------------------------------------------------------------------+
//|                                                     Pluto v1.mq4 |
//|                                              Todd Copyright 2006 |
//| modified by Kalenzo, contact@fxservice.eu
//| http://www.fxservice.eu
//+------------------------------------------------------------------+
#property copyright "Todd Copyright 2006"
#property link      "None"

extern double Lots=1.0;
extern int Slippage=3;
extern string EAName = "Pluto v1";
extern int MagicNumber = 1491;

extern int MaxTrades = 1;

extern int GMTShift=0;

extern int StartTime=06;
extern int StopTime=08;

extern int MaxOpenTradeHours = 15;
extern int MaxOpenTradeMins = 0;
extern int MaxOpenTradeSecs = 0;

extern double StopLossPips = 15; 
extern double ProfitPips = 100;  
extern double TrailStart = 15;
extern double TrailStop = 15;
extern double ScalpPips = 10;

//Juice
extern int JuicePeriod = 7;
extern double minJuiceLevel = 2;
//AltrTrend
extern int K=30;
extern double Kstop=0.5;
extern int Kperiod=150;
extern int PerADX=14;
extern int CountBars=1000;
//StepMA
extern int PeriodWATR=100;
extern double Kwatr=1.0000;
extern int Advance=0;
extern int HighLow=0;
//TriggerLines
extern int Rperiod = 30;
extern int LSMA_Period = 15;
//StepMAStoch
extern int SPeriodWATR=10;
extern double SKwatr=1.0000;
extern int SHighLow=0;
//StepRSI
extern int PeriodRSI=14;
extern int StepSizeFast=8;
extern int StepSizeSlow=12;
//StepSTO
extern double Kfast=1.0000;
extern double Kslow=1.2000;


extern bool MM = false; //Use Money Management or not
extern double RiskPercent = 2; //% of margin available per trade

extern int Current = 1;
extern int TimeFrame = 0;
extern bool DoScalp = false;
extern bool UseIndicatorClose = true;

datetime timeprev=0, PrevTradeTime=0;
datetime expiration, exittime;
double Lo, Hi, Range, Stop, LongEntry, ShortEntry, StopLoss, TakeProfit, Spread;
double price, prcopp,iLots, MinDist;
int AdjustedStart, AdjustedStop;

int init()
{
 return(0);
}

int deinit()
{
 return(0);
}

int start()
{

  AdjustedStart = StartTime + GMTShift;
  AdjustedStop = StopTime + GMTShift;
  
  if(DoScalp) Scalp();
  TrailingAlls(TrailStart, TrailStop); 
  if(CurTime() >= exittime) CloseAll();
 

 if(timeprev==Time[0])
  return(0);
 timeprev=Time[0];

 
  RefreshRates();
 
  double cJuice = iStdDev(Symbol(),TimeFrame,JuicePeriod,MODE_EMA,0,PRICE_CLOSE,Current)/Point;
  // Altr = 1 is bullish, Altr = 0 is bearish
  double Altr=iCustom(Symbol(),TimeFrame,"AltrTrend_Signal",K,Kstop,Kperiod,PerADX,CountBars,2,Current);
  // StepMA = 1 is bullish, Altr = 0 is bearish
  double StepMA=iCustom(Symbol(),TimeFrame,"StepMA_Color",PeriodWATR,Kwatr,Advance,HighLow,2,Current);
  //TL1 > TL2 is Bullish and vice versa is bearish
  double TL1=iCustom(Symbol(),TimeFrame,"Triggerlines",Rperiod,LSMA_Period,0,Current);
  double TL2=iCustom(Symbol(),TimeFrame,"Triggerlines",Rperiod,LSMA_Period,1,Current);
  //MASTO1 > MASTO2 is Bullish and vice versa is bearish
  double MASTO1=iCustom(Symbol(),TimeFrame,"StepMA_Stoch_v1",SPeriodWATR,SKwatr,SHighLow,0,Current);
  double MASTO2=iCustom(Symbol(),TimeFrame,"StepMA_Stoch_v1",SPeriodWATR,SKwatr,SHighLow,1,Current);
  //RSI1 > RSI2 is Bullish and vice versa is bearish
  double RSI1=iCustom(Symbol(),TimeFrame,"StepRSI_v2",PeriodRSI,StepSizeFast,StepSizeSlow,0,Current);
  double RSI2=iCustom(Symbol(),TimeFrame,"StepRSI_v2",PeriodRSI,StepSizeFast,StepSizeSlow,2,Current);
  //STO1 > STO2 is Bullish and vice versa is bearish
  double STO1=iCustom(Symbol(),TimeFrame,"StepSto_v1",Kfast,Kslow,0,Current);
  double STO2=iCustom(Symbol(),TimeFrame,"StepSto_v1",Kfast,Kslow,1,Current);

   
 {
  expiration=0;
  exittime = CurTime()+(MaxOpenTradeHours*60*60)+(MaxOpenTradeMins*60)+(MaxOpenTradeSecs);
    
  Spread = MarketInfo(Symbol(), MODE_SPREAD)*Point;
  MinDist = MarketInfo(Symbol(), MODE_STOPLEVEL)*Point;
   
  Stop = StopLossPips; 
  TakeProfit = ProfitPips;
  
  if(MM==true) 
   iLots = LotSize(Stop);
  else
   iLots = Lots;

  if(UseIndicatorClose)
  { 
   if(CountLongs() >= 1)
    if((RSI1<RSI2 && STO1<STO2) || (RSI1<RSI2 && MASTO1<MASTO2) || (MASTO1<MASTO2 && STO1<STO2))
    {
     CloseLongs();
    }
    
   if(CountShorts() >= 1)
    if((RSI1>RSI2 && STO1>STO2) || (RSI1>RSI2 && MASTO1>MASTO2) || (MASTO1>MASTO2 && STO1>STO2))
    {
     CloseShorts();
    }
  }

 if((TimeHour(CurTime())>=AdjustedStart) && (TimeHour(CurTime())<=AdjustedStop))
 if(CountTrades() < MaxTrades && CurTime() - PrevTradeTime > Period()*60*1000)
 if(cJuice >= minJuiceLevel && Altr>=1 && StepMA>=1 && TL1>TL2  && MASTO1>MASTO2 
                                                                     && RSI1>RSI2 && STO1>STO2)
  {
   CloseShorts();
   RefreshRates();
   LongEntry = MarketInfo(Symbol(), MODE_ASK);
   price=LongEntry;
   prcopp=LongEntry - Spread;
   OpenPendingOrder(OP_BUY,iLots,price,Slippage,prcopp,Stop,TakeProfit,EAName,MagicNumber,0,Green);
   PrevTradeTime = CurTime();
  }

 if((TimeHour(CurTime())>=AdjustedStart) && (TimeHour(CurTime())<=AdjustedStop))
 if(CountTrades() < MaxTrades && CurTime() - PrevTradeTime > Period()*60*1000)
 if(cJuice >= minJuiceLevel && Altr<=0 && StepMA<=0 && TL1<TL2 && MASTO1<MASTO2 
                                                                     && RSI1<RSI2 && STO1<STO2)
  {
   CloseLongs();
   RefreshRates();
   ShortEntry = MarketInfo(Symbol(), MODE_BID);  
   price=ShortEntry;
   prcopp=ShortEntry + Spread;
   OpenPendingOrder(OP_SELL,iLots,price,Slippage,prcopp,Stop,TakeProfit,EAName,MagicNumber,0,Red);
   PrevTradeTime = CurTime();
  } 

 }//Open Pending
 

 return(0);
}

double StopLong(double price,int stop)
{
 if(stop==0)
  return(0);
 else
  return(price-(stop*Point));
}

double StopShort(double price,int stop)
{
 if(stop==0)
  return(0);
 else
  return(price+(stop*Point));
}

double TakeLong(double price,int take)
{
 if(take==0)
  return(0);
 else
  return(price+(take*Point));
}

double TakeShort(double price,int take)
{
 if(take==0)
  return(0);
 else
  return(price-(take*Point));
}


void TrailingAlls(int start,int stop)
{
 int profit;
 double stoptrade;
 double stopcal;
 
 if(stop==0)
  return;
 
 int trade;
 for(trade=OrdersTotal()-1;trade>=0;trade--)
 {
  if(!OrderSelect(trade,SELECT_BY_POS,MODE_TRADES))
   continue;

  if(OrderSymbol()!=Symbol()||OrderMagicNumber()!=MagicNumber)
   continue;

  if(OrderSymbol()==Symbol()||OrderMagicNumber()==MagicNumber)
  {
   if(OrderType()==OP_BUY)
   {
    profit=NormalizeDouble((Bid-OrderOpenPrice())/Point,0);
    if(profit<start)
     continue;
    stoptrade=OrderStopLoss();
    stopcal=Bid-(stop*Point);
    if(stoptrade==0||(stoptrade!=0&&stopcal>stoptrade))
     OrderModify(OrderTicket(),OrderOpenPrice(),stopcal,OrderTakeProfit(),0,Blue);
   }//Long
  
   if(OrderType()==OP_SELL)
   {
    profit=NormalizeDouble((OrderOpenPrice()-Ask)/Point,0);
    if(profit<start)
     continue;
    stoptrade=OrderStopLoss();
    stopcal=Ask+(stop*Point);
    if(stoptrade==0||(stoptrade!=0&&stopcal<stoptrade))
     OrderModify(OrderTicket(),OrderOpenPrice(),stopcal,OrderTakeProfit(),0,Red);
   }//Shrt
  }
  Sleep(1000);
 }//for
}


void CloseAll()
{
 int trade;
 for(trade=OrdersTotal()-1;trade>=0;trade--)
 {
  OrderSelect(trade,SELECT_BY_POS,MODE_TRADES);

  if(OrderSymbol()!=Symbol())
   continue;
  if(OrderSymbol()==Symbol() && OrderMagicNumber()== MagicNumber)
  {
   if(OrderType()==OP_BUY)
    OrderClose(OrderTicket(),OrderLots(),Bid,Slippage,Blue);

   if(OrderType()==OP_SELL)
    OrderClose(OrderTicket(),OrderLots(),Ask,Slippage,Red);
  }
  Sleep(1000);
 }
}

int OpenPendingOrder(int pType,double pLots,double pLevel,int sp, double pr, int sl, int tp,string pComment,int pMagic,datetime pExpiration,color pColor)
{
  int ticket=0;
  int err=0;
  int c = 0;
  int NumberOfTries = 100;
  switch (pType)
  {
		case OP_BUY:
        {  
			Alert("I want to open buy order");
        }   
         break;
		case OP_BUYLIMIT:
        {
			Alert("I want to open buy limit order");
		}		
        break;
		case OP_BUYSTOP:
        {
			Alert("I want to open buy stop order");
		}
        break;
		case OP_SELL:
        {
			Alert("I want to open sell order");
		}
        break;
		case OP_SELLLIMIT:
        {
			Alert("I want to open sell limit order");
		}
        break;
		case OP_SELLSTOP:
        {
			Alert("I want to open sell stop order");
		}
        break;
  } 
  
//  Print("Error = ", err);
//  Sleep(1000);
  return(ticket);
}  

double LotSize(double StopLossInPips)
{ 
 int Leverage =  AccountLeverage(); 
 double PipValue = MarketInfo(Symbol(), MODE_TICKVALUE);
 double lotMM;

 lotMM = NormalizeDouble((AccountFreeMargin()*RiskPercent/100)/(StopLossInPips*PipValue),1);
   
   if (lotMM < 0.1) lotMM = Lots;
   if  (lotMM > 100) lotMM = 100;
   return (lotMM);
} 

//+------------------------------------------------------------------+
// Set Tight TP
//+------------------------------------------------------------------+
void Scalp(){
double res;int error;

 int trade;
  for(trade=OrdersTotal()-1;trade>=0;trade--)
  {
      OrderSelect(trade,SELECT_BY_POS,MODE_TRADES);
      if(OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber ){
         if(OrderType()==OP_BUY){
            if(Bid - OrderOpenPrice() >= ScalpPips*Point){
               res = OrderClose(OrderTicket(),OrderLots(),Bid,3,White); // close 
               if(res<0){
                  error=GetLastError();
                  Print("Error = ",error);
               }
            }
         }
         if(OrderType()==OP_SELL){
            if(OrderOpenPrice() - Ask >= ScalpPips*Point){
               res = OrderClose(OrderTicket(),OrderLots(),Ask,3,White); // close 
               if(res<0){
                  error=GetLastError();
                  Print("Error = ",error);
               }
            }
         }
      }
  }
}


int CountTrades()
{
 int count=0;
 int trade;
 for(trade=OrdersTotal()-1;trade>=0;trade--)
 {
  OrderSelect(trade,SELECT_BY_POS,MODE_TRADES);
  
  if(OrderSymbol()!=Symbol()||OrderMagicNumber()!=MagicNumber)
   continue;
   
  if(OrderSymbol()==Symbol()&&OrderMagicNumber()==MagicNumber)
  if(OrderType()==OP_BUY || OrderType()==OP_SELL)
   count++;
 }//for
 return(count);
}

void CloseLongs()
{
 int trade;
 for(trade=OrdersTotal()-1;trade>=0;trade--)
 {
  OrderSelect(trade,SELECT_BY_POS,MODE_TRADES);

  if(OrderSymbol()!=Symbol())
   continue;
  if(OrderSymbol()==Symbol() && OrderMagicNumber()== MagicNumber)
  {
   if(OrderType()==OP_BUY)
    OrderClose(OrderTicket(),OrderLots(),Bid,Slippage,Blue);
  }
  Sleep(1000);
 }
}

void CloseShorts()
{
 int trade;
 for(trade=OrdersTotal()-1;trade>=0;trade--)
 {
  OrderSelect(trade,SELECT_BY_POS,MODE_TRADES);

  if(OrderSymbol()!=Symbol())
   continue;
  if(OrderSymbol()==Symbol() && OrderMagicNumber()== MagicNumber)
  {
   if(OrderType()==OP_SELL)
    OrderClose(OrderTicket(),OrderLots(),Ask,Slippage,Red);
  }
  Sleep(1000);
 }
}

int CountLongs()
{
 int count=0;
 int trade;
 for(trade=OrdersTotal()-1;trade>=0;trade--)
 {
  OrderSelect(trade,SELECT_BY_POS,MODE_TRADES);
  
  if(OrderSymbol()!=Symbol()||OrderMagicNumber()!=MagicNumber)
   continue;
   
  if(OrderSymbol()==Symbol()&&OrderMagicNumber()==MagicNumber)
  if(OrderType()==OP_BUY)
   count++;
 }//for
 return(count);
}

int CountShorts()
{
 int count=0;
 int trade;
 for(trade=OrdersTotal()-1;trade>=0;trade--)
 {
  OrderSelect(trade,SELECT_BY_POS,MODE_TRADES);
  
  if(OrderSymbol()!=Symbol()||OrderMagicNumber()!=MagicNumber)
   continue;
   
  if(OrderSymbol()==Symbol()&&OrderMagicNumber()==MagicNumber)
  if(OrderType()==OP_SELL)
   count++;
 }//for
 return(count);
}